package hibintro.v1.run;



import hibintro.util.HibernateUtil;
import hibintro.v1.model.User;

import java.util.List;

import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

/**
 * @author goik
 * 
 * Retrieval all {@link User} attributes from a database.
 *
 */
public class GetUsersAsAttributes {

  /**
   * Retrieving a single {@link User} instance by means
   * of its primary key value "goik".
   * @param args unused
   */
  public static void main(String[] args) {
    final Session session = HibernateUtil.createSessionFactory("hibernate.cfg.xml").openSession();

    final Transaction transaction = session.beginTransaction();

    final Query searchUsers = session.createQuery("select uid, cname from User");

    @SuppressWarnings("unchecked")
    final Object queryResult = searchUsers.list();
    System.out.println("queryResult type:" + queryResult.getClass().getSimpleName());
    final List<Object> usersAttributes = (List<Object>) queryResult;
    for (final Object o: usersAttributes) {
      System.out.println("result set element type:" + o.getClass().getSimpleName());
      final Object attributes[] = (Object []) o;
      for (Object attribute: attributes) {
        System.out.println("attribute value:" + attribute);
      }
    }

    transaction.commit();
  }
}